/* Routine to calculate the cosine of an angle */
Say "Enter the angle in radians:"
Parse Pull Angle
Say "How many digits of precision?"
Parse Pull NDigits
Numeric Digits NDigits+1
Limit=10**-(NDigits+1)
C=cos(Angle)
Say "Cos("||Angle||") =" C

Exit 

Cos:
/* Compute the cosine of an angle in radians */
Procedure Expose Limit
Parse Arg Angle
Sum=1
Sign=1
Epsilon=1
Old=0
i=0
Do While Epsilon > Limit
   i=i+2
   Sign=-1*Sign
   Sum=Sum+Sign*(Angle**i/Factorial(i))
   Say "Sum:" Sum
   Epsilon=Old-Sum
   If Epsilon<0  then
      Epsilon=-1*Epsilon
   Old=Sum
end /* do */

Return Sum
Factorial:
Procedure
Parse Arg N
Prod=1
Do j=N to 2 By -1
   Prod=Prod*j
end /* do */
Return Prod
